//+------------------------------------------------------------------+
//|                                                  checkingmt5.mq5 |
//|                                     Copyright 2017, Company Name |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2017, Company Name"
#property link      "http://www.mql5.com"
#property version   "1.00"

//#include <mq4-.mqh>
#include <mt4orders.mqh>
#include <mql4_to_mql5.mqh>

int TrailingStop = 20;
int TrailingStep = 5;
int MagicNumber = 12;
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+

int buycount = 0;
int OnInit()
  {
//---
   
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---
   
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
//---
  //TrailingPositions();
  
    if (buycount ==0)
    {
      OrderSend(Symbol(),OP_BUY, 0.01,Ask, 0, 0,0,"",0,0,clrNONE);
      buycount = 1;
    }
   /* for(int i = 0; i < PositionsTotal(); i++)
    {
      int _ticket = PositionGetTicket(i);
      Print(_ticket);
    }*/
  }
  
void TrailingPositions()
{
	double pp = Point;
	if (Digits == 3 || Digits == 5 || Digits == 1)
		pp = Point * 10;
	if (Digits == 6)
		pp = Point * 100;
	if (Digits == 7)
		pp = Point * 1000;
	if (OrdersTotal() > 0)
	{
		for (int cnt = OrdersTotal() - 1; cnt >= 0 ; cnt--)
		{
			if (OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES))
				if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber)
				{
					if (OrderType() == OP_BUY)
					{
						if (Bid - OrderOpenPrice() > TrailingStop * pp)
						{
							if (OrderStopLoss() == 0 || OrderStopLoss() < Bid - (TrailingStop + TrailingStep) * pp)
							{
								ModifyStopLoss(OrderTicket(), Bid - TrailingStop * pp);
								//Print(OrderTicket());
								return;
							}
						}
					}
					if (OrderType() == OP_SELL)
					{
						if (OrderOpenPrice() - Ask > TrailingStop * pp)
						{
							if (OrderStopLoss() == 0 || OrderStopLoss() > Ask + (TrailingStop + TrailingStep) * pp)
							{
								ModifyStopLoss(OrderTicket(), Ask + TrailingStop * pp);
								return;
							}
						}
					}
				}
		}
	}
}
//function that modifies the stoploss
void ModifyStopLoss(int _ticket, double ldStopLoss)
{
	bool fm;
	while (IsTradeAllowed() == false)
		Sleep(100);
	//RefreshRates();
	fm = OrderModify(_ticket, OrderOpenPrice(), ldStopLoss, OrderTakeProfit(), 0, CLR_NONE);
	if (fm == false)
	{
		//error = GetLastError();
		Print(" ModifyStopLoss failed to execute (retrying) " + Symbol()/* + " (" + string(error) + ") " + ErrorDescription(error) + ", ticket ", OrderTicket()*/);
		fm = OrderModify(_ticket, OrderOpenPrice(), ldStopLoss, OrderTakeProfit(), 0, CLR_NONE);
	}
	else
	{
		Print(" ModifyStopLoss success " + Symbol());
	}
}
//+------------------------------------------------------------------+
